LeetCode Algorithms #292 <Nim Game>

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思路:
先考虑AB都只拿一次的情况,即游戏只进行一轮,列出所有可能的石头数量会发现,后拿者如果想获得胜利,石头总数必须为4。

归纳看整个拿石头的过程,后拿者想要确保游戏胜利,必须保证下个拿取周期,就是对方拿石子的时候,石子是4的倍数。

因此只有石头一开始就是4的倍数时,后拿石头的人才可以获得胜利。除此之外,先拿石头的人总是能获得胜利。


解:

class Solution {
public:
    bool canWinNim(int n) {
        return (n%4);
    }
};


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值